#include "gpx2shp.h"

void
getReference(g2sprop * pr, xmlNodePtr cur)
{
#ifdef DEBUG
    printf("[getReference()]\n");
#endif
    if (pr->verbose) {
	printf("<gpx>\n");
    }
    cur = cur->xmlChildrenNode;
    while (cur != NULL) {
	if (pr->parseWpt) {
	    if ((!xmlStrcmp(cur->name, (const xmlChar *) "wpt"))) {
		wptRoot(pr, cur);
	    }
	}
	if (pr->parseTrk) {
	    if ((!xmlStrcmp(cur->name, (const xmlChar *) "trk"))) {
		trkRoot(pr, cur);
	    }
	}
	if (pr->parseRte) {
	    if ((!xmlStrcmp(cur->name, (const xmlChar *) "rte"))) {
		rteRoot(pr, cur);
	    }
	}
	cur = cur->next;
    }
    return;
}

void
parseDoc(g2sprop * pr)
{
#ifdef DEBUG
    printf("[parseDoc()]\n");
#endif
    xmlNodePtr      cur;
    pr->doc = xmlParseFile(pr->sourcefile);
    if (pr->doc == NULL) {
	fprintf(stderr, "Document not parsed successfully. \n");
	return;
    }
    cur = xmlDocGetRootElement(pr->doc);
    if (cur == NULL) {
	fprintf(stderr, "Empty document\n");
	xmlFreeDoc(pr->doc);
	return;
    }
    if (xmlStrcmp(cur->name, (const xmlChar *) "gpx")) {
	fprintf(stderr,
		"document of the wrong type, root node is not gpx.\n");
	xmlFreeDoc(pr->doc);
	return;
    }
    if (pr->verbose) {
	printf("Source file: %s  Output file: %s\n", pr->sourcefile,
	       pr->output);
    }
    getReference(pr, cur);
    xmlFreeDoc(pr->doc);
    return;
}
