#include "gpx2shp.h"
void
failToWriteWptAttr(int iShape, int col, char *source)
{
#ifdef DEBUG
    printf("(failToWriteWptAttr)\n");
#endif
    printf("Fail to write a attribute in %s . shapeid:%i col:%i\n", source,
	   iShape, col);
}

void
writeWptAttribute(DBFHandle hDBF, wptType * wpt, int iShape)
{
    if (!DBFWriteIntegerAttribute(hDBF, iShape, 0, iShape))
	failToWriteWptAttr(iShape, 0, "createTrkTable");
    if (!DBFWriteDoubleAttribute(hDBF, iShape, 1, wpt->ele))
	failToWriteWptAttr(iShape, 1, "createTrkTable");
    if (!DBFWriteStringAttribute(hDBF, iShape, 2, wpt->time))
	failToWriteWptAttr(iShape, 1, "createTrkTable");
    if (!DBFWriteDoubleAttribute(hDBF, iShape, 3, wpt->magvar))
	failToWriteWptAttr(iShape, 2, "createTrkTable");
    if (!DBFWriteDoubleAttribute(hDBF, iShape, 4, wpt->geoidheight))
	failToWriteWptAttr(iShape, 3, "createTrkTable");
    if (!DBFWriteStringAttribute(hDBF, iShape, 5, wpt->name))
	failToWriteWptAttr(iShape, 4, "createTrkTable");
    if (!DBFWriteStringAttribute(hDBF, iShape, 6, wpt->cmt))
	failToWriteWptAttr(iShape, 5, "createTrkTable");
    if (!DBFWriteStringAttribute(hDBF, iShape, 7, wpt->desc))
	failToWriteWptAttr(iShape, 6, "createTrkTable");
    if (!DBFWriteStringAttribute(hDBF, iShape, 8, wpt->src))
	failToWriteWptAttr(iShape, 7, "createTrkTable");
    if (!DBFWriteStringAttribute(hDBF, iShape, 9, wpt->link))
	failToWriteWptAttr(iShape, 8, "createTrkTable");
    if (!DBFWriteStringAttribute(hDBF, iShape, 10, wpt->sym))
	failToWriteWptAttr(iShape, 9, "createTrkTable");
    if (!DBFWriteStringAttribute(hDBF, iShape, 11, wpt->type))
	failToWriteWptAttr(iShape, 10, "createTrkTable");
    if (!DBFWriteIntegerAttribute(hDBF, iShape, 12, wpt->sat))
	failToWriteWptAttr(iShape, 11, "createTrkTable");
    if (!DBFWriteDoubleAttribute(hDBF, iShape, 13, wpt->hdop))
	failToWriteWptAttr(iShape, 12, "createTrkTable");
    if (!DBFWriteDoubleAttribute(hDBF, iShape, 14, wpt->vdop))
	failToWriteWptAttr(iShape, 13, "createTrkTable");
    if (!DBFWriteDoubleAttribute(hDBF, iShape, 15, wpt->ageofdgpsdata))
	failToWriteWptAttr(iShape, 14, "createTrkTable");
    if (!DBFWriteDoubleAttribute(hDBF, iShape, 16, wpt->gdpsid))
	failToWriteWptAttr(iShape, 15, "createTrkTable");
}

void
getWptChildren(g2sprop * pr, xmlNodePtr cur, wptType * wpt)
{
    char           *wpttag[] =
	{ "ele", "time", "magvar", "geoidheight", "name", "cmt", "desc",
"src",
	"link", "sym", "type", "sat", "hdop", "vdop", "ageofdgpsdata",
	    "gdpsid",
	"extensions"
    };
    int             i;
    xmlChar        *element;
#ifdef DEBUG
    printf("(getWptChildren)\n");
#endif
    if (pr->verbose) {
    /*
     * printf (" point\n"); 
     */
    }
    cur = cur->xmlChildrenNode;
    while (cur != NULL) {
	for (i = 0; i < 16; i++) {
	    if ((!xmlStrcmp(cur->name, (const xmlChar *) wpttag[i]))) {
		element =
		    xmlNodeListGetString(pr->doc, cur->xmlChildrenNode, 1);
		if (i == 0)	/* "ele" */
		    wpt->ele = atof(element);
		if (i == 1)	/* "time" */
		    strcpy(wpt->time, element);
		if (i == 2)	/* "magvar" */
		    wpt->magvar = atof(element);
		if (i == 3)	/* "geoidheight" */
		    wpt->geoidheight = atof(element);
		if (i == 4)	/* "name" */
		    strcpy(wpt->name, element);
		if (i == 5)	/* "cmt" */
		    strcpy(wpt->cmt, element);
		if (i == 6)	/* "desc" */
		    strcpy(wpt->desc, element);
		if (i == 7)	/* "src" */
		    strcpy(wpt->src, element);
		if (i == 8)	/* "link" */
		    strcpy(wpt->link, element);
		if (i == 9)	/* "sym" */
		    strcpy(wpt->sym, element);
		if (i == 10)	/* "type" */
		    strcpy(wpt->type, element);
		if (i == 11)	/* "sat" */
		    wpt->sat = atof(element);
		if (i == 12)	/* "hdop" */
		    wpt->hdop = atof(element);
		if (i == 13)	/* "vdop" */
		    wpt->vdop = atof(element);
		if (i == 14)	/* "ageofdgpsdata" */
		    wpt->ageofdgpsdata = atof(element);
		if (i == 15)	/* "gdpsid" */
		    wpt->gdpsid = atof(element);
	    /*
	     * if (i == 16 ) //"extensions" strcpy (wpt->extensions,
	     * element); 
	     */
		xmlFree(element);
	    }
	}
	cur = cur->next;
    }
    return;
}

void
addWptField(DBFHandle hDBF)
{
    DBFAddField(hDBF, "shapeID", FTInteger, 8, 0);
    DBFAddField(hDBF, "ele", FTDouble, 16, 4);
    DBFAddField(hDBF, "time", FTString, TIMELENGTH, 0);
    DBFAddField(hDBF, "magvar", FTDouble, 16, 4);
    DBFAddField(hDBF, "geoidht", FTDouble, 16, 4);
    DBFAddField(hDBF, "name", FTString, NAMELENGTH, 0);
    DBFAddField(hDBF, "cmt", FTString, COMMENTLENGTH, 0);
    DBFAddField(hDBF, "desc", FTString, COMMENTLENGTH, 0);
    DBFAddField(hDBF, "src", FTString, COMMENTLENGTH, 0);
    DBFAddField(hDBF, "link", FTString, FILENAMELENGTH, 0);
    DBFAddField(hDBF, "sym", FTString, NAMELENGTH, 0);
    DBFAddField(hDBF, "type", FTString, NAMELENGTH, 0);
    DBFAddField(hDBF, "sat", FTInteger, 8, 0);
    DBFAddField(hDBF, "hdop", FTDouble, 16, 4);
    DBFAddField(hDBF, "vdop", FTDouble, 16, 4);
    DBFAddField(hDBF, "agedpgs", FTDouble, 16, 4);
    DBFAddField(hDBF, "gdpsid", FTDouble, 16, 4);
}

void
initWptType(wptType * wpt)
{
    wpt->ele = 0;
    wpt->time[0] = '\0';
    wpt->magvar = 0;
    wpt->geoidheight = 0;
    wpt->name[0] = '\0';
    wpt->cmt[0] = '\0';
    wpt->desc[0] = '\0';
    wpt->src[0] = '\0';
    wpt->link[0] = '\0';
    wpt->sym[0] = '\0';
    wpt->type[0] = '\0';
    wpt->sat = 0;
    wpt->hdop = 0;
    wpt->vdop = 0;
    wpt->ageofdgpsdata = 0;
    wpt->gdpsid = 0;
}

void
getWpt(SHPHandle hSHP, DBFHandle hDBF, g2sprop * pr, xmlNodePtr cur)
{
    xmlChar        *lat;
    xmlChar        *lon;
    int             iShape = 1;
    SHPObject      *shpobj;
    double          x[1],
                    y[1],
                    z[1],
                    m[1];
    wptType         wpt;
#ifdef DEBUG
    printf("(getWpt)\n");
#endif
    if (pr->verbose) {
	printf("  <wpt>\n");
    }
    initWptType(&wpt);
    lat = xmlGetProp(cur, "lat");
    lon = xmlGetProp(cur, "lon");
    x[0] = atof(lon);
    y[0] = atof(lat);
    getWptChildren(pr, cur, &wpt);
    z[0] = wpt.ele;
    m[0] = 1.0;
    if (pr->is3d) {
	shpobj =
	    SHPCreateObject(SHPT_POINTZ, iShape, 0, 0, 0, 1, x, y, z, m);
    } else {
	shpobj =
	    SHPCreateObject(SHPT_POINT, iShape, 0, 0, 0, 1, x, y, NULL,
			    NULL);
    }

    iShape = SHPWriteObject(hSHP, -1, shpobj);
    SHPDestroyObject(shpobj);
    writeWptAttribute(hDBF, &wpt, iShape);
    xmlFree(lat);
    xmlFree(lon);
    return;
}

void
wptRoot(g2sprop * pr, xmlNodePtr cur)
{
#ifdef DEBUG
    printf("(wptroot)\n");
#endif
    static int      isFirstWpt = 0;
    char            output_wpt[FILENAMELENGTH];

    if (!isFirstWpt) {
	strcpy(output_wpt, pr->output);
	strcat(output_wpt, "_wpt");

	if (pr->is3d) {
	    pr->hSHP_wpt = SHPCreate(output_wpt, SHPT_POINTZ);
	} else {
	    pr->hSHP_wpt = SHPCreate(output_wpt, SHPT_POINT);
	}
	pr->hDBF_wpt = DBFCreate(output_wpt);
	addWptField(pr->hDBF_wpt);
	isFirstWpt = 1;
    }
    getWpt(pr->hSHP_wpt, pr->hDBF_wpt, pr, cur);
    pr->stats->wptpoints++;
    return;
}
